<?php
require getcwd() . "/classes/functions.php";
class htaccess{
    var $fHtaccess=""; // path and filename for htaccess file
    var $fHtgroup="";  // path and filename for htgroup file
    var $fPasswd="";   // path and filename for passwd file

	/**
	* Control file
	* This file contains the usernames and unencrypted passwords
	*/
	var $fControl="";	// path and filename for control file which contains usernamenames and unencrypted passwords
    
    var $authType="Basic"; // Default authentification type
    var $authName="Internal area"; // Default authentification name

    /**
    * Initialising class htaccess
    */
    function htaccess(){
    }

    /**
    * Sets the filename and path of .htaccess to work with
    * @param string	$filename    the name of htaccess file
    */
    function setFHtaccess($filename){
        $this->fHtaccess=$filename;
    }
    
    /**
    * Sets the filename and path of the htgroup file for the htaccess file
    * @param string	$filename    the name of htgroup file
    */
    function setFHtgroup($filename){
        $this->fHtgroup=$filename;
    }
    
    /**
    * Sets the filename and path of the password file for the htaccess file
    * @param string	$filename    the name of htgroup file
    */
    function setFPasswd($filename){
        $this->fPasswd=$filename;
		$this->fControl=$filename . ".control";
    }
	
	function getFPasswd() {
		return $this->fPasswd;
	}

    /**
    * Adds a user to the password file
    * @param string $username     Username
    * @param string $password     Password for Username
    * @param string $group        Groupname for User (optional)
    * @return boolean $created         Returns true if user have been created otherwise false
    */
    function addUser($username,$password,$group,$expiry,$email){
        // checking if user already exists
        $file=@fopen($this->fPasswd,"r");
        $isAlready=false;
        while($line=@fgets($file,200)){
            $lineArr=explode(":",$line);
            if($username==$lineArr[0]){
                $isAlready=true;
				echo "found username<BR>";
             }
        }
        
        if($isAlready==false){
            $file=fopen($this->fPasswd,"a");
            $c_password=crypt($password);
            $newLine=$username.":".$c_password.":".$expiry.":".$email."\n";
            fputs($file,$newLine);
            fclose($file);

			// Update control file
			$control=fopen($this->fControl,"a");
			$controlLine=$username.":".$password . ":".$expiry.":".$email."\n";
			fputs($control,$controlLine);
			fclose($control);
            return true;
        }else{
            return false;
        }
    }

    /** FOR RESUBMITTING PURPOSES
    * Adds a user to the password file
    * @param string $username     Username
    * @param string $password     Password for Username
    * @param string $group        Groupname for User (optional)
    * @return boolean $created         Returns true if user have been created otherwise false
    */
    function addUserResubmit($username,$password,$group,$expiry,$email){
        // checking if user already exists
        $file=@fopen($this->fPasswd,"r");
        $isAlready=false;
        while($line=@fgets($file,200)){
            $lineArr=explode(":",$line);
            if($username==$lineArr[0]){
                $isAlready=true;
				echo "found username<BR>";
             }
        }
        
        if($isAlready==false){
            $file=fopen($this->fPasswd,"a");
            $c_password=crypt($password);
            $newLine=$username.":".$c_password.":".$expiry.":".$email."\n";
            fputs($file,$newLine);
            fclose($file);

            return true;
        }else{
            return false;
        }
    }

    /**
    * Adds a group to the htgroup file
    * @param string $groupname     Groupname
    */
    function addGroup($groupname){
        $file=fopen($this->fHtgroup,"a");
        fclose($file);
    }

    /**
    * Deletes a user in the password file
    * @param string $username     Username to delete
    * @return boolean $deleted    Returns true if user have been deleted otherwise false
    */
    function delUser($username){
        // Reading names from file
        $file=fopen($path.$this->fPasswd,"r");
        $i=0;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
            if($username!=$lineArr[0]){
                $newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=$lineArr[1];
				$newUserlist[$i][2]=$lineArr[2];
				$newUserlist[$i][3]=$lineArr[3];
                $i++;
            }else{
                $deleted=true;
            }
        }
        fclose($file);

        // Writing names back to file (without the user to delete)
        $file=fopen($path.$this->fPasswd,"w");
        for($i=0;$i<count($newUserlist);$i++){
            fputs($file,trim($newUserlist[$i][0]).":".trim(crypt($newUserlist[$i][1])).":".trim($newUserlist[$i][2]).":".trim($newUserlist[$i][3])."\n");
        }
        fclose($file);

		/*********************************************************
		// Update Control file
        // Reading names from file
		**********************************************************/
        $file=fopen($path.$this->fControl,"r");
        $i=0;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
            if($username!=$lineArr[0]){
                $newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=$lineArr[1];
				$newUserlist[$i][2]=$lineArr[2];
				$newUserlist[$i][3]=$lineArr[3];
                $i++;
            }else{
                $deleted=true;
            }
        }
        fclose($file);

        // Writing names back to control file (without the user to delete)
        $file=fopen($path.$this->fControl,"w");
        for($i=0;$i<count($newUserlist);$i++){
            fputs($file,trim($newUserlist[$i][0]).":".trim($newUserlist[$i][1]).":".trim($newUserlist[$i][2]).":".trim($newUserlist[$i][3])."\n");
        }
        fclose($file);
        
        if($deleted==true){
            return true;
        }else{
            return false;
        }
    }
    
    /**
    * Deletes a user in the password file
    * @param string $username     Username to delete
    * @return boolean $deleted    Returns true if user have been deleted otherwise false
    */
    function delExpired(){
        // Reading names from file
        $file=fopen($path.$this->fPasswd,"r");
        $i=0;
		$D=date("d");
		$M=date("m");
		$Y=date("Y");
		$TJD = gregorian($Y,$M,$D);
		$deleted=false;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
			$date=explode("/",$lineArr[2]);
			$Y=$date[0];
			$M=$date[1];
			$D=$date[2];
			$JD = gregorian($Y,$M,$D);
            if($JD<=$TJD && trim($lineArr[2])>""){
				echo "Deleting <B>username:</B> $lineArr[0], <B>password:</B> $lineArr[1], <B>expiry:</B> $lineArr[2], <B>email:</B> $lineArr[3]<BR>";
				$deleted=true;
            }else{
 				$newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=$lineArr[1];
				$newUserlist[$i][2]=$lineArr[2];
				$newUserlist[$i][3]=$lineArr[3];
                $i++;
           }
        }
        fclose($file);

        // Writing names back to file (without the user to delete)
        $file=fopen($path.$this->fPasswd,"w");
        for($i=0;$i<count($newUserlist);$i++){
            fputs($file,trim($newUserlist[$i][0]).":".trim(crypt($newUserlist[$i][1])).":".trim($newUserlist[$i][2]).":".trim($newUserlist[$i][3])."\n");
        }
        fclose($file);

		/*********************************************************
		// Update Control file
        // Reading names from file
		**********************************************************/
        $file=fopen($path.$this->fControl,"r");
        $i=0;
		$D=date("d");
		$M=date("m");
		$Y=date("Y");
		$TJD = gregorian($Y,$M,$D);
		$deleted=false;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
			$date=explode("/",$lineArr[2]);
			$Y=$date[0];
			$M=$date[1];
			$D=$date[2];
			$JD = gregorian($Y,$M,$D);
            if($JD<=$TJD && trim($lineArr[2])>""){
				echo "Deleting <B>username:</B> $lineArr[0], <B>password:</B> $lineArr[1], <B>expiry:</B> $lineArr[2], <B>email:</B> $lineArr[3]<BR>";
				$deleted=true;
            }else{
 				$newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=$lineArr[1];
				$newUserlist[$i][2]=$lineArr[2];
				$newUserlist[$i][3]=$lineArr[3];
                $i++;
           }
        }
        fclose($file);

        // Writing names back to control file (without the user to delete)
        $file=fopen($path.$this->fControl,"w");
        for($i=0;$i<count($newUserlist);$i++){
            fputs($file,trim($newUserlist[$i][0]).":".trim($newUserlist[$i][1]).":".trim($newUserlist[$i][2]).":".trim($newUserlist[$i][3])."\n");
        }
        fclose($file);

		return $deleted;        
    }
    
    /**
    * Deletes a user in the password file
    * @param string $email			Email of user to delete
    * @return boolean $deleted    Returns true if user have been deleted otherwise false
    */
    function delEmail($email){
        // Reading names from file
        $file=fopen($path.$this->fPasswd,"r");
        $i=0;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
            if(trim($email)!=trim($lineArr[3])){
                $newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=$lineArr[1];
				$newUserlist[$i][2]=$lineArr[2];
				$newUserlist[$i][3]=$lineArr[3];
                $i++;
            }else{
                $deleted=true;
            }
        }
        fclose($file);

        // Writing names back to file (without the user to delete)
        $file=fopen($path.$this->fPasswd,"w");
        for($i=0;$i<count($newUserlist);$i++){
            fputs($file,trim($newUserlist[$i][0]).":".trim(crypt($newUserlist[$i][1])).":".trim($newUserlist[$i][2]).":".trim($newUserlist[$i][3])."\n");
        }
        fclose($file);

		/*********************************************************
		// Update Control file
        // Reading names from file
		**********************************************************/
        $file=fopen($path.$this->fControl,"r");
        $i=0;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
            if(trim($email)!=trim($lineArr[3])){
                $newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=$lineArr[1];
				$newUserlist[$i][2]=$lineArr[2];
				$newUserlist[$i][3]=$lineArr[3];
                $i++;
            }else{
                $deleted=true;
            }
        }
        fclose($file);

        // Writing names back to control file (without the user to delete)
        $file=fopen($path.$this->fControl,"w");
        for($i=0;$i<count($newUserlist);$i++){
            fputs($file,trim($newUserlist[$i][0]).":".trim($newUserlist[$i][1]).":".trim($newUserlist[$i][2]).":".trim($newUserlist[$i][3])."\n");
        }
        fclose($file);

        if($deleted==true){
            return true;
        }else{
            return false;
        }
    }
    
    /**
    * Delete all users in the password file
    * @return boolean $deleted    Returns true if user have been deleted otherwise false
    */
    function delAllUsers($switch){
		if ($switch==1 || $switch==3) {
			// Writing names back to file (without the user to delete)
			$file=fopen($path.$this->fPasswd,"w");
			fputs($file,"");
			fclose($file);
		} 
		if ($switch==2 || $switch==3) {
			$file=fopen($path.$this->fControl,"w");
			fputs($file,"");
			fclose($file);
		}
        return true;

    }
    
    /**
    * Updates a user in the password file
    * @param string $username		Username to update
	* @param string $password		New password
	* @param string $expiry			Expiry date
	* @param string $email			Email address
    * @return boolean $update		Returns true if user have been updated otherwise false
    */
    function updateUser($username,$password,$expiry,$email){
        // Reading names from file
        $file=fopen($path.$this->fPasswd,"r");
        $i=0;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
            if($username!=$lineArr[0]){
				// copy unchanged records to the array
				if(trim($lineArr[0]) != " ") {
					// make sure string isn't empty
					// trim off all spaces and /n
	                $newUserlist[$i][0]=rtrim($lineArr[0]);
	                $newUserlist[$i][1]=rtrim($lineArr[1]);
					$newUserlist[$i][2]=rtrim($lineArr[2]);
					$newUserlist[$i][3]=rtrim($lineArr[3]);
					$i++;
				} 
            }else{
				// copy changed record to the array
                $newUserlist[$i][0]=rtrim($username);
                $newUserlist[$i][1]=rtrim(crypt($password));
				$newUserlist[$i][2]=rtrim($expiry);
				$newUserlist[$i][3]=rtrim($email);
                $updated=true;
				$i++;
            }
        }
        fclose($file);

        // Writing names back to file
        $file=fopen($path.$this->fPasswd,"w");
        for($i=0;$i<count($newUserlist);$i++){
			if (trim($newUserlist[$i][0]) != " ") {
				fputs($file,$newUserlist[$i][0].":".$newUserlist[$i][1].":".$newUserlist[$i][2].":".$newUserlist[$i][3]."\n");
			}
        }
        fclose($file);

		/*********************************************************
		// Update Control file
        // Reading names from file
		**********************************************************/
        $file=fopen($path.$this->fControl,"r");
        $i=0;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
            if($username!=$lineArr[0]){
				// copy unchanged records to the array
				if(trim($lineArr[0]) != " ") {
					// make sure string isn't empty
					// trim off all spaces and /n
	                $newUserlist[$i][0]=rtrim($lineArr[0]);
	                $newUserlist[$i][1]=rtrim($lineArr[1]);
					$newUserlist[$i][2]=rtrim($lineArr[2]);
					$newUserlist[$i][3]=rtrim($lineArr[3]);
					$i++;
				} 
            }else{
				// copy changed record to the array
                $newUserlist[$i][0]=rtrim($username);
                $newUserlist[$i][1]=rtrim($password);
				$newUserlist[$i][2]=rtrim($expiry);
				$newUserlist[$i][3]=rtrim($email);
                $updated=true;
				$i++;
            }
        }
        fclose($file);

        // Writing names back to control file
        $file=fopen($path.$this->fControl,"w");
        for($i=0;$i<count($newUserlist);$i++){
			if (trim($newUserlist[$i][0]) != " ") {
				fputs($file,$newUserlist[$i][0].":".$newUserlist[$i][1].":".$newUserlist[$i][2].":".$newUserlist[$i][3]."\n");
			}
        }
        fclose($file);
       
        if($updated==true){
            return true;
        }else{
            return false;
        }
    }
    
    /**
    * Returns an array of all users in a password file
    * @return array $users         All usernames of a password file in an array
    * @see setFPasswd()
    */
    function getUsers(){
        // Reading names from file
        $file=fopen($path.$this->fPasswd,"r");
        $i=0;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
            $newUserlist[$i][0]=$lineArr[0];
            $newUserlist[$i][1]=$lineArr[1];
			$newUserlist[$i][2]=$lineArr[2];
			$newUserlist[$i][3]=$lineArr[3];
            $i++;
        }
        fclose($file);
		return $newUserlist;
    }

	/**
	* Returns a users' record from the password file
	* @return list $user	Four fields of a users' record as a list
	*/
	function getUser($username) {
		//Reading names from file
		$file=fopen($path.$this->fPasswd,"r");
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
			if ($lineArr[0] == $username) {
				$newUserlist[0]=$lineArr[0];
				$newUserlist[1]=$lineArr[1];
				$newUserlist[2]=$lineArr[2];
				$newUserlist[3]=$lineArr[3];
			}
        }
        fclose($file);
		return $newUserlist;
	}

	/**
	* Returns a users' record from the password file
	* @return list $user	Four fields of a users' record as a list
	*/
	function getEmail($email) {
		//Reading names from file
		$file=fopen($path.$this->fPasswd,"r");
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
			if (trim($lineArr[3]) == trim($email)) {
				$newUserlist[0]=$lineArr[0];
				$newUserlist[1]=$lineArr[1];
				$newUserlist[2]=$lineArr[2];
				$newUserlist[3]=$lineArr[3];
			}
        }
        fclose($file);
		return $newUserlist;
	}

	/**
	* Returns the username of the last record in the password file
	* @return string $username
	*/
	function getLastUser() {
		//Reading names from file
		$username="";
		$file=fopen($path.$this->fPasswd,"r");
		while($line=fgets($file,200)) {
			$lineArr=explode(":",$line);
			if (trim($lineArr[0]) != "") {
				$username=$lineArr[0];
			}
		}
		return $username;
	}
    
	/**
	* Searches for a record on $username and returns true if found
	* @return boolean	True if username is found, else false
	*/
	function findUser($username) {
		//Reading names from file
		$file=fopen($path.$this->fPasswd,"r");
		$i=0;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
			if ($lineArr[0] == $username) {
		        fclose($file);
				return true;
			}
        }
        fclose($file);
		return false;
	}
    
	/**
	* Searches for a record on $email and returns true if found
	* @return boolean		True if email address is found, else false
	*/
	function findEmail($email) {
		//Reading names from file
		$file=fopen($path.$this->fPasswd,"r");
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
			if ($email == "") {
				fclose($file);
				return false;
			} elseif (trim($lineArr[3]) == trim($email)) {
		        fclose($file);
				return true;
			}
        }
        fclose($file);
		return false;
	}
    
    /**
    * Sets a password to the given username
    * @param string $username     The name of the User for changing password
    * @param string $password     New Password for the User
    * @return boolean $isSet      Returns true if password have been set
    */    
    function setPasswd($username,$new_password){
        // Reading names from file
        $newUserlist="";
        $file=fopen($this->fPasswd,"r");
        $x=0;
        for($i=0;$line=fgets($file,200);$i++){
            $lineArr=explode(":",$line);
            if($username!=$lineArr[0] && $lineArr[0]!="" && $lineArr[1]!=""){
                $newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=$lineArr[1];
                $x++;
            }else if($lineArr[0]!="" && $lineArr[1]!=""){
                $newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=crypt($new_password)."\n";
                $isSet=true;
                $x++;
            }
        }
        fclose($file);

        unlink($this->fPasswd);

        /// Writing names back to file (with new password)
        $file=fopen($this->fPasswd,"w");
        for($i=0;$i<count($newUserlist);$i++){
            $content=$newUserlist[$i][0].":".$newUserlist[$i][1];
            fputs($file,$content);
        }
        fclose($file);

		/*********************************************************
		// Update Control file
        // Reading names from file
		**********************************************************/
        $newUserlist="";
		$file=fopen($this->fControl,"r");
        $x=0;
        for($i=0;$line=fgets($file,200);$i++){
            $lineArr=explode(":",$line);
            if($username!=$lineArr[0] && $lineArr[0]!="" && $lineArr[1]!=""){
                $newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=$lineArr[1];
                $x++;
            }else if($lineArr[0]!="" && $lineArr[1]!=""){
                $newUserlist[$i][0]=$lineArr[0];
                $newUserlist[$i][1]=$new_password."\n";
                $isSet=true;
                $x++;
            }
        }
        fclose($file);

        unlink($this->fControl);

        /// Writing names back to control file (with new password)
        $file=fopen($this->fControl,"w");
        for($i=0;$i<count($newUserlist);$i++){
            $content=$newUserlist[$i][0].":".$newUserlist[$i][1];
            fputs($file,$content);
        }
        fclose($file);



        if($isSet==true){
            return true;
        }else{
            return false;
        }
    }

    /**
    * Sets the Authentification type for Login
    * @param string $authtype     Authentification type as string
    */
    function setAuthType($authtype){
        $this->authType=$authtype;
    }

    /**
    * Sets the Authentification Name (Name of the login area)
    * @param string $authname     Name of the login area
  	*/
    function setAuthName($authname){
        $this->authName=$authname;
    }

    /**
    * Writes the htaccess file to the given Directory and protects it
    * @see setFhtaccess()
  	*/
    function addLogin(){
       $file=fopen($this->fHtaccess,"w+");
       fputs($file,"Order allow,deny\n");
       fputs($file,"Allow from all\n");
       fputs($file,"AuthType        ".$this->authType."\n");
       fputs($file,"AuthUserFile    ".$this->fPasswd."\n\n");
       fputs($file,"AuthName        \"".$this->authName."\"\n");
       fputs($file,"require valid-user\n");
       fclose($file);
    }

	/**
	* Creates empty htpasswd file in the protected directory
	*/
	function createPasswd() {
		$file=fopen($this->fPasswd,"w+");
		fclose($file);
		$file=fopen($this->fControl,"w+");
		fclose($file);
	}

    /**
    * Deletes the protection of the given directory
    * @see setFhtaccess()
    */
    function delLogin(){
        unlink($this->fHtaccess);
    }

    /**
    * Sorts an array of all users in a password file
    * @return array $users         All usernames of a password file in an array
    * @see setFPasswd()
    */
    function sortUsers(){
        // Reading names from file
        $file=fopen($path.$this->fPasswd,"r");
        $i=0;
        while($line=fgets($file,200)){
            $lineArr=explode(":",$line);
   			$sortarray[$i]=$lineArr[0];
	        $newUserlist[$i][0]=$lineArr[0];
            $newUserlist[$i][1]=$lineArr[1];
			$newUserlist[$i][2]=$lineArr[2];
			$newUserlist[$i][3]=$lineArr[3];
            $i++;
        }
		array_multisort($newUserlist,$sortarray);
		return $newUserlist;

        fclose($file);
    }

}

?>
